// Numerical Recipes in C++, 2nd edition, pg. 733

int assume(bool);
int static_assert(bool);
int unknown();

//Vec_DP *x_p;
//Mat_DP *d_p;

void
////NR::bsstep(Vec_IO_DP & y, Vec_IO_DP & dydx, DP & xx, const DP htry,
function()
//const DP eps, Vec_I_DP & yscal, DP & hdid, DP & hnext,
//void derivs(const DP, Vec_I_DP &, Vec_O_DP &))
{
  int y_dim1;
  assume(y_dim1 > 0);
  int yscal_dim1;
  assume(yscal_dim1 == y_dim1);

  int a_dim1;
  assume(a_dim1 > 0);
  int alf_dim1;
  assume(alf_dim1 > 0);
  int alf_dim2;
  assume(alf_dim2 > 0);
  int d_dim1;
  assume(d_dim1 > 0);
  int err_dim1;
  assume(err_dim1 > 0);

  const int KMAXX = 8, IMAXX = (KMAXX + 1);
  //const DP SAFE1 = 0.25, SAFE2 = 0.7, REDMAX = 1.0e-5, REDMIN = 0.7;
  //const DP TINY = 1.0e-30, SCALMX = 0.1;

  //static const int nseq_d[IMAXX] =
  // {
  // 2, 4, 6, 8, 10, 12, 14, 16, 18};

  ///*static*/ int first = 1, kmax, kopt;
  int kmax, kopt;
  assume(kopt >= 1);
  assume(kopt < KMAXX - 1);  

  //static DP epsold = -1.0, xnew;
  //static Vec_DP a(IMAXX);
  //static Mat_DP alf(KMAXX, KMAXX);
  //bool exitflag = false;
  int i, iq, k, kk, km, reduct;
  //DP eps1, errmax, fact, h, red, scale, work, wrkmin, xest;
  // Vec_INT nseq(nseq_d, IMAXX);
  int nseq_dim1 = IMAXX;
  
  //Vec_DP err(KMAXX);

  int nv = y_dim1;
  //Vec_DP yerr(nv), ysav(nv), yseq(nv);
  //x_p = new Vec_DP(KMAXX);
  //d_p = new Mat_DP(nv, KMAXX);
  int yerr_dim1 = nv;
  int ysav_dim1 = nv;

  if (unknown() /*eps != epsold*/)
    {
      // hnext = xnew = -1.0e29;
      //eps1 = SAFE1 * eps;
      //a[0] = nseq[0] + 1;
      //static_assert(0 <= 0);
      //static_assert(0 < a_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < nseq_dim1);
      for (k = 0; k < KMAXX; k++)
	{
	  //a[k + 1] = a[k] + nseq[k + 1];
	  //static_assert(0 <= k + 1);
	  //static_assert(k + 1 < a_dim1);
	  static_assert(0 <= k);
	  //static_assert(k < a_dim1);
	  //static_assert(0 <= k + 1);
	  //static_assert(k + 1 < nseq_dim1);
	}
      for (iq = 1; iq < KMAXX; iq++)
	{
	  for (k = 0; k < iq; k++) {
	    //alf[k][iq] =
	    //pow(eps1, (a[k + 1] - a[iq + 1]) /
	    //((a[iq + 1] - a[0] + 1.0) * (2 * k + 3)));
	    //static_assert(0 <= k);
	    //static_assert(k < alf_dim1);
	    //static_assert(0 <= iq);
	    //static_assert(iq < alf_dim2);
	    //static_assert(0 <= k + 1);
	    //static_assert(k + 1 < a_dim1);
	    //static_assert(0 <= iq + 1);
	    //static_assert(iq + 1 < a_dim1);

	    //static_assert(0 <= iq + 1);
	    //static_assert(iq + 1 < a_dim1);
	    //static_assert(0 <= 0);
	    //static_assert(0 < a_dim1);
	  }
	}
      // epsold = eps;
      for (kopt = 1; kopt < KMAXX - 1; kopt++) {
	//static_assert(0 <= kopt + 1);
	//static_assert(kopt + 1 < a_dim1);
	//static_assert(0 <= kopt);
	//static_assert(kopt < a_dim1);
	//static_assert(0 <= kopt - 1);
	//static_assert(kopt - 1 < alf_dim1);
	//static_assert(0 <= kopt);
	//static_assert(kopt < alf_dim2);
	if (unknown() /*a[kopt + 1] > a[kopt] * alf[kopt - 1][kopt]*/)
	{
	  break;
	}
      }
      kmax = kopt;
    }
  // h = htry;
  for (i = 0; i < nv; i++)
    {
      //ysav[i] = y[i];
      //static_assert(0 <= i);
      //static_assert(i < ysav_dim1);
      //static_assert(0 <= i);
      //static_assert(i < y_dim1);
    }
  if (unknown() /*xx != xnew || h != hnext*/)
    {
      // first = 1;
      kopt = kmax;
    }
  reduct = 0;
  for (;;)
    {
      for (k = 0; k <= kmax; k++)
	{
	  // xnew = xx + h;
	  // if (xnew == xx)
	  //   {
	  //     nrerror("step size underflow in bsstep");
	  //   }
	  //mmid(ysav, dydx, xx, h, nseq[k], yseq, derivs);
	  //static_assert(0 <= k);
	  //static_assert(k < nseq_dim1);
	  //xest = SQR(h / nseq[k]);
	  //static_assert(0 <= k);
	  //static_assert(k < nseq_dim1);
	  // pzextr(k, xest, yseq, y, yerr);
	  if (k != 0)
	    {
	      // errmax = TINY;
	      for (i = 0; i < nv; i++)
		{
		  //errmax = MAX(errmax, fabs(yerr[i] / yscal[i]));
		  //static_assert(0 <= i);
		  //static_assert(i < yerr_dim1);
		  //static_assert(0 <= i);
		  //static_assert(i < yscal_dim1);
		}
	      // errmax /= eps;
	      km = k - 1;
	      //err[km] = pow(errmax / SAFE1, 1.0 / (2 * km + 3));
	      //static_assert(0 <= km);
	      //static_assert(km < err_dim1);
	    }
	  if (k != 0 /*&& (k >= kopt - 1 || first)*/)
	    {
	      // if (errmax < 1.0)
	      // 	{
	      // 	  exitflag = true;
	      // 	  break;
	      // 	}
	      if (k == kmax || k == kopt + 1)
		{
		  //red = SAFE2 / err[km];
		  //static_assert(0 <= km);
		  //static_assert(km < err_dim1);
		  break;
		}
	      else {
	      //static_assert(0 <= kopt - 1);
	      //static_assert(kopt - 1 < alf_dim1);
	      //static_assert(0 <= kopt);
	      //static_assert(kopt < alf_dim2);
	      //static_assert(0 <= km);
	      //static_assert(km < err_dim1);
	      if (unknown() /*k == kopt && alf[kopt - 1][kopt] < err[km]*/)
	      {
		//red = 1.0 / err[km];
		//static_assert(0 <= km);
		//static_assert(km < err_dim1);
		break;
	      }
	      else {
		//static_assert(0 <= km);
	      //static_assert(km < alf_dim1);
	      //static_assert(0 <= kmax - 1);
	      //static_assert(kmax - 1 < alf_dim2);
	      //static_assert(0 <= km);
	      //static_assert(km < err_dim1);
		if (unknown() /*kopt == kmax && alf[km][kmax - 1] < err[km]*/)
	      {
		//red = alf[km][kmax - 1] * SAFE2 / err[km];
		//static_assert(0 <= km);
		//static_assert(km < alf_dim1);
		//static_assert(0 <= kmax - 1);
		//static_assert(kmax - 1 < alf_dim2);
		//static_assert(0 <= km);
		//static_assert(km < err_dim1);
		break;
	      }
		else {
		//static_assert(0 <= km);
	      //static_assert(km < alf_dim1);
	      //static_assert(0 <= kopt);
	      //static_assert(kopt < alf_dim2);
	      //static_assert(0 <= km);
	      //static_assert(km < err_dim1);
	      if (unknown() /*alf[km][kopt] < err[km]*/)
	      {
		//red = alf[km][kopt - 1] / err[km];
		//static_assert(0 <= km);
		//static_assert(km < alf_dim1);
		//static_assert(0 <= kopt - 1);
		//static_assert(kopt - 1 < alf_dim2);
		//static_assert(0 <= km);
		//static_assert(km < err_dim1);
		break;
	      }
	      }
	      }
	      }
	    }
	}
      // if (exitflag)
      // 	{
      // 	  break;
      // 	}
      // red = MIN(red, REDMIN);
      // red = MAX(red, REDMAX);
      // h *= red;
      reduct = 1;
    }
  // xx = xnew;
  // hdid = h;
  // first = 0;
  // wrkmin = 1.0e35;
  for (kk = 0; kk <= km; kk++)
    {
      //fact = MAX(err[kk], SCALMX);
      //static_assert(0 <= kk);
      //static_assert(kk < err_dim1);
      //work = fact * a[kk + 1];
      //static_assert(0 <= kk + 1);
      //static_assert(kk + 1 < a_dim1);
      if (unknown() /*work < wrkmin*/)
	{
	  // scale = fact;
	  // wrkmin = work;
	  kopt = kk + 1;
	}
    }
  // hnext = h / scale;
  if (unknown() /*kopt >= k && kopt != kmax && !reduct*/)
    {
      //fact = MAX(scale / alf[kopt - 1][kopt], SCALMX);
      //static_assert(0 <= kopt - 1);
      //static_assert(kopt - 1 < alf_dim1);
      //static_assert(0 <= kopt);
      //static_assert(kopt < alf_dim2);

      //static_assert(0 <= kopt + 1);
      //static_assert(kopt + 1 < a_dim1);
      if (unknown() /*a[kopt + 1] * fact <= wrkmin*/)
      {
	// hnext = h / fact;
	kopt++;
      }
    }
  // delete d_p;
  // delete x_p;
}
